<?php
namespace App\Http\Controllers\WeChatApplet\Verify\AppletAccountManage;

use Validator;
use App\Http\Requests;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use App\Http\Controllers\Controller;

class VerifyAppletReceivableAnalyzeController extends Controller
{
    // 列表验证器
    public function indexValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'pri_id.required' => '参数错误',
            'pri_id.integer' => '数据类型不正确',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'pri_id' => 'required|integer'
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 单量验证器
    public function billNumberValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.integer' => '数据类型不正确',
            'orbi_id.min' => '参数错误',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orbi_id' => 'required|integer|min:1',
            'type' => [
                    'required',
                     Rule::in(['1', '2']),
                ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 结款获取数据验证器
    public function getInfoValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.integer' => '数据类型不正确',
            'orbi_id.min' => '参数错误',
            'type.required' => '参数错误',
            'type.in' => '参数错误'
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orbi_id' => 'required|integer|min:1', //账单id
            'type' => [ //1.获取数据 2.提交数据
                    'required',
                     Rule::in(['1', '2']),
                ]
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 结款提交验证器
    public function settleAccountsValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.integer' => '数据类型不正确',
            'orbi_id.min' => '参数错误',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
            'orbi_payment_type.required' => '请选择结款类型',
            'orbi_payment_type.in' => '参数错误',
            'acti_id.required_unless' => '请选择会计科目',
            'acti_id.integer' => '参数错误',
            'acti_id.min' => '参数错误',
            'orbi_actual_price.required' => '请输入实收金额',
            'orbi_actual_price.numeric' => '实收金额参数错误',
            'orbi_actual_price.min' => '实收金额参数错误',
            'zero_price.required_if' => '请输入抹零金额',
            'zero_price.numeric' => '抹零金额参数错误',
            'zero_price.min' => '抹零金额参数错误',
            'orbi_remark.sometimes' => '请输入备注',
            'orbi_remark.max' => '备注长度255超过最大限制',
            // 'orbi_img.required_unless' => '请上传结款凭证',
            // 'orbi_img.array' => '结款凭证参数错误',
            'orbi_client_id.required' => '请输入客户id',
            'orbi_client_id.integer' => '参数错误',
            'orbi_client_id.min' => '参数错误',
            'orbi_type.required' => '客户类型',
            'orbi_type.in' => '参数错误',
            'recr_actual_price.required_if' => '请输入预收款金额',
            'recr_actual_price.numeric' => '预收款金额参数错误',
            'recr_actual_price.min' => '预收款金额参数错误',
            'recr_id.required_if' => '请选择预收款',
            'recr_id.integer' => '预收款参数错误',
            'recr_id.min' => '预收款参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [ 
            'orbi_id' => 'required|integer|min:1', //账单id
            'type' => [ //1.获取数据 2.提交数据
                    'required',
                     Rule::in(['1', '2']),
                ],
            'orbi_payment_type' => [ //结算类型1.抹零 2.分期结款 3.预收款抵账 4.正常
                    'required',
                     Rule::in(['1', '2', '3', '4']),
                ],
            'acti_id' => 'required_unless:orbi_payment_type,3|integer|min:1', //会计科目id
            'orbi_actual_price' => 'required|numeric|min:0', //实收金额
            'zero_price' => 'required_if:orbi_payment_type,1|numeric|min:0', //抹零金额
            'orbi_remark' => 'sometimes|max:255', //备注
            // 'orbi_img' => 'required_unless:orbi_payment_type,3|array', //结款凭证
            'orbi_type' => [ //客户类型：1.门店零售 2.来往单位
                    'required',
                     Rule::in(['1', '2', '3']),
                ], // 客户类型 1.门店零售 2.来往单位
            'orbi_client_id' => 'required|integer|min:0', // 会员/来往单位id
            'recr_id' => 'required_if:orbi_payment_type,3|integer|min:1', // 预收款id
            'recr_actual_price' => 'required_if:orbi_payment_type,3|numeric|min:0', // 预收款钱数
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 审核验证器
    public function auditValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.integer' => '数据类型不正确',
            'orbi_id.min' => '参数错误',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
            'orbi_state.required_if' => '参数错误',
            'orbi_state.in' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orbi_id' => 'required|integer|min:1',
            'type' => [
                    'required',
                     Rule::in(['1', '2']),
                ],
            'orbi_state' => [
                    'required_if:type,2',
                     Rule::in(['1', '4']), //同意：1 驳回：4
                ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 删除验证器
    public function delValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.integer' => '数据类型不正确',
            'orbi_id.min' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orbi_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 搜索预收款验证器
    public function advanceMoneyValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'client_id.required' => '参数错误',
            'client_id.integer' => '数据类型不正确',
            'client_id.min' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'client_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 编辑验证器
    public function editValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.integer' => '数据类型不正确',
            'orbi_id.min' => '参数错误',
            'orbi_number.required' => '参数错误',
            'orbi_number.max' => '参数错误',
            'ord_id.required' => '参数错误',
            'ord_id.array' => '数据类型不正确'
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orbi_id' => 'required|integer|min:1',
            'orbi_number' => 'required|max:20',
            'ord_id' => 'required|array',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    } 

    // 批量结算
    public function clearingValidator($data)
    {
        // 自定义错误消息
        $messages = [
            // 'acti_id.required' => '参数错误',
            // 'acti_id.integer' => '数据类型不正确',
            // 'acti_id.min' => '参数错误',
            'content.required' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            // 'acti_id' => 'required|integer|min:1',
            'content' => 'required',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 批量结算显示页面
    public function clearingShowValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orbi_id.required' => '参数错误',
            'orbi_id.array' => '数据类型不正确',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orbi_id' => 'required|array',
            'type' => [
                'required',
                 Rule::in(['1', '2', '3']),
            ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 开票验证器
    // public function openNoteValidator($data)
    // {
    //     // 自定义错误消息
    //     $messages = [
    //         'orbi_id.required' => '参数错误',
    //         'orbi_id.integer' => '数据类型不正确',
    //         'orbi_id.min' => '参数错误',
    //     ];

    //     // 数据验证
    //     $validator = Validator::make($data, [
    //         'orbi_id' => 'required|integer|min:1',
    //     ], $messages);

    //     // 判断数据验证是否成功
    //     if ($validator->fails()) {
    //         return $validator->errors();
    //     }
    // }
}
